% ukazka nacteni souboru, volani funkce, minimalizace a nakresleni

clear

% nacteni dat - jasnost planetky v zavislosti na case
fid = fopen('./sklad/1.lcgo', 'r');
% pocet bodu
n = fscanf(fid, '%d', 1);
% vektor od planetky ke Slunci 
sun = zeros(n,3);
% vektor od planetky k Zemi 
earth = zeros(n,3);
for i = 1:n
    % vektor ke Slunci
    sun(i,1:3) = fscanf(fid, '%f', 3)';
    % vektor k Zemi
    earth(i,1:3) = fscanf(fid, '%f', 3)';
    % JD
    jd(i) = fscanf(fid, '%f', 1);
    % jasnost
    br(i) = fscanf(fid, '%f', 1);
    % fazovy uhel (Slunce - planetka - Zeme)
    alfa(i) = acos(sum(earth(i,:) .* sun(i,:)) / norm(sun(i,:)) / norm(earth(i,:)));
end

% normalizace
br = br / mean(br);

% nakresleni dat
figure(1)
clf
subplot(2,1,1)
% jasnost v zavislosti na case
plot(jd, br, 'b.', 'MarkerSize', 10)
xlabel('JD')
ylabel('brightness')

% prolozeni zavislosti jasnosti na fazi funkci ve tvaru 
% br = a * exp(-alfa / b) + c * alfa + 1
% a, b, c jsou parametry

param = fminsearch('chisq', [1 1 1], [], alfa, br)

% spocitej hustou krivku
x = min(alfa):0.01:max(alfa);
y = fazova_funkce(param, x);

% fit polynomem m-teho stupne
m = 2;
param_poly = polyfit(alfa, br, m);

% nakresleni jasnost vs. faze
subplot(2,2,3)
plot(alfa / pi * 180, br, '.', 'MarkerSize', 10)
hold on
plot(x / pi * 180, y, 'r', 'LineWidth', 3)
plot(x / pi * 180, polyval(param_poly, x), 'k', 'LineWidth', 3)
% lze vyuzit nektere znaky z LaTeXu
xlabel('phase angle \alpha [deg], \alpha = cos^{-1}({\bf n}_e . {\bf n}_s)')
ylabel('brightness')

% ulozeni obrazku v ruznych formatech
print -depsc2 sklad/faze
print -dpng sklad/faze
print -djpeg sklad/faze
